/**
Generate your own custom-cookie-cutters<br/>
by <a href="http://www.local-guru.net/blog">Guru</a>
*/

int EDIT=0;
int EXPORT=1;
int HELP=2;

import processing.opengl.*;
import unlekker.data.*;
//PVector[] p;
List data;
import java.util.List;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.io.*;

String exportFileName = "test.stl";
PImage traceimage;

void setup() {
  size(500,500,OPENGL);
  smooth();
  
  //p = new PVector[20];
  data = new ArrayList();
  
  for( int i=0; i < 20; i++) {
    float r = width/10 + random(width/10);
    data.add( new PVector( width/2  + cos( radians( i * 18 )) * r, height/2 + sin( radians( i * 18 )) * r ));
  }
}

int dragged = -1;

int mode = EDIT;

void draw() {
  if ( mode == EDIT ) {
    edit();
  } else if ( mode == EXPORT ) {
    noLoop();
    export( exportFileName );
    mode = EDIT;
    loop();
  } else if  ( mode == HELP ) {
    help();
  }
}

void keyPressed() {
  if ( mode == HELP ) {
    mode = EDIT;
    return;
  }

  if ( key == 'e' ) {
    exportDialog();
    loop();
  } else if ( key == 'h' ) {
    mode = HELP;
  } else if ( key == 'r' ) {
    clear();
  } else if ( key == 'c' ) {
    circle();
  } else  if ( key == '+' ) {
    addNode();
  } else if ( key == '-' ) {
    removeNode();
  } else if ( key ==  's' ) {
    saveDialog();
  } else if ( key == 'l' ) {
    loadDialog();
  } else if ( key == 't' ) {
    loadBackgroundDialog();
  }
}

void edit() {
  background(128);
  fill(255, traceimage == null ? 255 : 200);
  
  if (traceimage != null) {
     boolean landscape = traceimage.width > traceimage.height;
     imageMode( CENTER );
    float h, w;
     if ( landscape ) {
       h = width * traceimage.height /traceimage.width;
       w = width;
     } else {
       h = height;
       w = height * traceimage.width / traceimage.height;

     }
     image( traceimage, width/2,height/2, w, h );

  }
  
  noStroke();
  PVector[] p = (PVector[])data.toArray(new PVector[]{});
  beginShape( TRIANGLE_STRIP );  
  for( int i = 0; i<p.length + 1; i++ ) {
    int last = (i - 1) % p.length;
    if (last < 0) last = p.length - 1;
    int next = (i + 1) % p.length;
    
    PVector tmp = new PVector( p[last].x, p[last].y );
    tmp.sub( p[next] );
    PVector n = new PVector( tmp.y, -tmp.x );
    
    vertex( p[i % p.length].x + n.x * 20 / p[last].dist(p[next]) , p[i % p.length].y + n.y * 20 / p[last].dist(p[next]) );
    vertex( p[i % p.length].x - n.x * 20 / p[last].dist(p[next]) , p[i % p.length].y - n.y * 20 / p[last].dist(p[next]) );
  }
  endShape(CLOSE);

  noFill();
  stroke(1); 
  
  beginShape();  
  for( int i = 0; i<p.length; i++ ) {
    if (mousePressed && mouseButton == LEFT && dragged < 0 ) {
      if (p[i].dist(new PVector(mouseX, mouseY)) < 4) {
        dragged = i;
      }
    } else if ( mousePressed && mouseButton == LEFT && dragged == i ) {
      p[i].x = mouseX;
      p[i].y = mouseY;
    }
    if ( !mousePressed ) {
      dragged =-1;
    }
    vertex( p[i].x, p[i].y );
  }
  endShape(CLOSE);
  fill(0);
  for( int i = 0; i<p.length; i++ ) {
    ellipse( p[i].x, p[i].y, 4, 4);
  }  
 
  fill(255); 
  text( "press 'h' for help", 10, height - 10 );

}

void export(String filename) {  
  
  float r1 = 10;
  float r2 = 1;
  float h1 = 4;
  float h2 = 40;
  float sc = 0.25;
  PVector[] p = (PVector[])data.toArray(new PVector[] {});
  println( "EXPORT");
  beginRaw("unlekker.data.STL", filename);
  translate( 115,115,260);
  scale( sc );
  //top  
  beginShape( TRIANGLE_STRIP );  
  for( int i = 0; i<p.length + 1; i++ ) {
    int last = (i - 1) % p.length;
    if (last < 0) last = p.length - 1;
    int next = (i + 1) % p.length;
    
    PVector tmp = new PVector( p[last].x, p[last].y );
    tmp.sub( p[next] );
    PVector n = new PVector( tmp.y, -tmp.x );
    
    vertex( p[i % p.length].x + n.x * r1 / p[last].dist(p[next]), p[i % p.length].y + n.y * r1 / p[last].dist(p[next]),0);
    vertex( p[i % p.length].x - n.x * r1 / p[last].dist(p[next]), p[i % p.length].y - n.y * r1 / p[last].dist(p[next]),0);
  }
  endShape(CLOSE);
  //inner wall
  beginShape( QUAD_STRIP );  
  for( int i = 0; i<p.length + 1; i++ ) {
    int last = (i - 1) % p.length;
    if (last < 0) last = p.length - 1;
    int next = (i + 1) % p.length;
    
    PVector tmp = new PVector( p[last].x, p[last].y );
    tmp.sub( p[next] );
    PVector n = new PVector( tmp.y, -tmp.x );
    
    vertex( p[i % p.length].x + n.x * r1 / p[last].dist(p[next]) , p[i % p.length].y + n.y * r1 / p[last].dist(p[next]),0);
    vertex( p[i % p.length].x + n.x * r1 / p[last].dist(p[next]) , p[i % p.length].y + n.y * r1 / p[last].dist(p[next]),h1);

  }
  endShape(CLOSE);
  //outer wall
  beginShape( QUAD_STRIP );  
  for( int i = 0; i<p.length + 1; i++ ) {
    int last = (i - 1) % p.length;
    if (last < 0) last = p.length - 1;
    int next = (i + 1) % p.length;
    
    PVector tmp = new PVector( p[last].x, p[last].y );
    tmp.sub( p[next] );
    PVector n = new PVector( tmp.y, -tmp.x );
    
    vertex( p[i % p.length].x - n.x * r1 / p[last].dist(p[next]) , p[i % p.length].y - n.y * r1 / p[last].dist(p[next]),0);
    vertex( p[i % p.length].x - n.x * r1 / p[last].dist(p[next]) , p[i % p.length].y - n.y * r1 / p[last].dist(p[next]),h1);
  }
  endShape(CLOSE);
  
  //top  
  beginShape( TRIANGLE_STRIP );  
  for( int i = 0; i<p.length + 1; i++ ) {
    int last = (i - 1) % p.length;
    if (last < 0) last = p.length - 1;
    int next = (i + 1) % p.length;
    
    PVector tmp = new PVector( p[last].x, p[last].y );
    tmp.sub( p[next] );
    PVector n = new PVector( tmp.y, -tmp.x );
    
    vertex( p[i % p.length].x + n.x * r1 / p[last].dist(p[next]) , p[i % p.length].y + n.y * r1 / p[last].dist(p[next]),h1);
    vertex( p[i % p.length].x - n.x * r1 / p[last].dist(p[next]) , p[i % p.length].y - n.y * r1 / p[last].dist(p[next]),h1);
  }
  endShape(CLOSE);

   //cutting part inner wall
  beginShape( QUAD_STRIP );  
  for( int i = 0; i<p.length + 1; i++ ) {
    int last = (i - 1) % p.length;
    if (last < 0) last = p.length - 1;
    int next = (i + 1) % p.length;
    
    PVector tmp = new PVector( p[last].x, p[last].y );
    tmp.sub( p[next] );
    PVector n = new PVector( tmp.y, -tmp.x );
    
    vertex( p[i % p.length].x + n.x * r2 / p[last].dist(p[next]) , p[i % p.length].y + n.y * r2 / p[last].dist(p[next]),h1);
    vertex( p[i % p.length].x + n.x * r2 / p[last].dist(p[next]) , p[i % p.length].y + n.y * r2 / p[last].dist(p[next]),h2);

  }
  endShape(CLOSE);
  //cutting part outer wall
  beginShape( QUAD_STRIP );  
  for( int i = 0; i<p.length + 1; i++ ) {
    int last = (i - 1) % p.length;
    if (last < 0) last = p.length - 1;
    int next = (i + 1) % p.length;
    
    PVector tmp = new PVector( p[last].x, p[last].y );
    tmp.sub( p[next] );
    PVector n = new PVector( tmp.y, -tmp.x );
    
    vertex( p[i % p.length].x - n.x * r2 / p[last].dist(p[next]) , p[i % p.length].y - n.y * r2 / p[last].dist(p[next]),h1);
    vertex( p[i % p.length].x - n.x * r2 / p[last].dist(p[next]) , p[i % p.length].y - n.y * r2 / p[last].dist(p[next]),h2);
  }
  endShape(CLOSE);
 
  //cutting part top  
  beginShape( TRIANGLE_STRIP );  
  for( int i = 0; i<p.length + 1; i++ ) {
    int last = (i - 1) % p.length;
    if (last < 0) last = p.length - 1;
    int next = (i + 1) % p.length;
    
    PVector tmp = new PVector( p[last].x, p[last].y );
    tmp.sub( p[next] );
    PVector n = new PVector( tmp.y, -tmp.x );
    
    vertex( p[i % p.length].x + n.x * r2 / p[last].dist(p[next]) , p[i % p.length].y + n.y * r2 / p[last].dist(p[next]),h2);
    vertex( p[i % p.length].x - n.x * r2 / p[last].dist(p[next]) , p[i % p.length].y - n.y * r2 / p[last].dist(p[next]),h2);
  }
  endShape(CLOSE);
  
  endRaw();
}

void clear() {
  data = new ArrayList();
  for( int i=0; i < 20; i++) {
    float r = width/10 + random(width/10);
    data.add(new PVector( width/2  + cos( radians( i * 18 )) * r, width/2 + sin( radians( i * 18 )) * r ));
  }
  traceimage = null;
}

void circle() {
  for( int i=0; i < data.size(); i++) {
    float a = 360.0/data.size();
    float r = width/6;
    data.set(i, new PVector( width/2  + cos( radians( i * a )) * r, width/2 + sin( radians( i * a )) * r ));
  }
}


void addNode() {
  PVector first = (PVector)data.get(0);
  PVector last = (PVector)data.get(data.size() -1 );

  PVector n = new PVector( first.x + (last.x - first.x)/2, first.y + (last.y  - first.y)/2);
  data.add( n );
}

void removeNode() {
  if ( data.size() > 3 ) {
    data.remove( data.size()-1);
  }
}

void saveCC(String filename) {
  println( filename );
  try {
    PrintWriter wr = new PrintWriter( new BufferedWriter( new FileWriter( filename )));
     
    for( int i =0; i < data.size(); i++) {
      PVector v = (PVector)data.get(i);
      wr.println( v.x + " " + v.y );
    } 
    wr.close();
  } catch (Exception e ) {
  }
}

void loadCC(String filename) {
  println( filename );
  try {
  
    BufferedReader br = new BufferedReader( new FileReader( filename ));
    data = new ArrayList();
    String in;
    while(( in = br.readLine()) != null ) {
       float x,y;
       
       String[] d = in.split(" ");
       x = Float.parseFloat(d[0]);
       y = Float.parseFloat(d[1]);
       data.add( new PVector( x, y ));
    }
    br.close();
  } catch ( Exception e ) {
  }
}

void loadBackgroundDialog() {
  try { 
    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
  } catch (Exception e) { 
    e.printStackTrace();  
  } 
  final JFileChooser fc = new JFileChooser();
  try {
  SwingUtilities.invokeLater(new Runnable() {
  public void run() {
      int ret = fc.showOpenDialog( parentFrame );
      if (ret == JFileChooser.APPROVE_OPTION) {
        traceimage = loadImage(fc.getSelectedFile().getAbsolutePath());
      }
  }
  });
  } catch ( Exception e ) {
  }
}


void exportDialog() {
  try { 
    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
  } catch (Exception e) { 
    e.printStackTrace();  
  } 
  final JFileChooser fc = new JFileChooser();
  try {
  SwingUtilities.invokeLater(new Runnable() {
  public void run() {
      int ret = fc.showSaveDialog( parentFrame );
      if (ret == JFileChooser.APPROVE_OPTION) {
        exportFileName = fc.getSelectedFile().getAbsolutePath();
        mode = EXPORT;
      }
  }
  });
  } catch ( Exception e ) {
  }
}


void saveDialog() {
  try { 
    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
  } catch (Exception e) { 
    e.printStackTrace();  
  } 
  final JFileChooser fc = new JFileChooser();
  try {
  SwingUtilities.invokeLater(new Runnable() {
  public void run() {
      int ret = fc.showSaveDialog( parentFrame );
      if (ret == JFileChooser.APPROVE_OPTION) {
        saveCC( fc.getSelectedFile().getAbsolutePath());
      }
  }
  });
  } catch ( Exception e ) {
  }
}

void loadDialog() {
  try { 
    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
  } catch (Exception e) { 
    e.printStackTrace();  
  } 
  final JFileChooser fc = new JFileChooser();
  try {
  SwingUtilities.invokeLater(new Runnable() {
  public void run() {
      int ret = fc.showOpenDialog( parentFrame );
      if (ret == JFileChooser.APPROVE_OPTION) {
        loadCC( fc.getSelectedFile().getAbsolutePath());
      }
  }
  });
  } catch ( Exception e ) {
  }
}



void help() {
  background(128);
  fill(255);
  rect( 10,10, width-20,height-20);
  fill(0);
  text( "CookieCutter - Helpscreen", 70,30 );
  
  text( "'h' .... show this help screen", 40, 80 );
  text( "'e' .... export a STL-file", 40, 95 );
  text( "'r' .... reset the cookiecutter", 40, 110 );
  text( "'c' .... make a circle", 40, 125 );
  text( "'l' .... load a cookiecutter", 40, 140 );
  text( "'s' .... save a cookiecutter", 40, 155 );
  text( "'t' .... load an image to trace", 40, 170 );
 
  text( "'+' .... add a point", 40, 200 );
  text( "'-' .... remove a point", 40, 215 );
  
  text( "press any key to exit this help screen", 30, 280 );
}
